import React from 'react'
import { reduxForm, Field } from 'redux-form'
import { Form } from 'semantic-ui-react'
import SemanticReduxFormField from '../components/SemanticReduxFormField'


const DomainForm = ({
  pristine,
  submitting,
  handleSubmit,
  ownerOptions,
}) => (
  <Form onSubmit={handleSubmit}>
    <Field component={Form.Input} type='text' placeholder='Name' name='name' />
    <Field component={Form.Input} type='number' placeholder='Ttl' name='ttl' />
    <Field
      options={ownerOptions()}
      component={SemanticReduxFormField}
      as={Form.Select}
      name='owner'
      type='text'
      search
    />
    <Form.Button disabled={pristine || submitting} type='submit'>Submit</Form.Button>
  </Form>
)

export default reduxForm({ form: 'domain' })(DomainForm)
